
local addonName, at = ...
local core = at.core

local main = CreateFrame('Frame', nil, UIParent)
main:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)

local hasCP, CLASS
local TextureIsShown
local TextureGetVertexColor

core:AddCallback('Initialize', 'resource', function(self, ...)
	local tab = {}

	-- no growth direction this time... it just seems like too much for a simple feature and detracts from the idea of the addon.
	tab.enabled = true
	tab.anchor = 'TOP'
	tab.relative = 'CENTER'
	tab.x = 0
	tab.y = -2
	tab.scale = 1
	
	self.db.resource = tab
end)


core:AddCallback('VariablesLoaded', 'combopoints', function(self, frame)
	local mine = false
	local function Update()
		if not mine then
			mine = true
			if NamePlateTargetResourceFrame and UnitExists('target') then
				local namePlateTarget = C_NamePlate.GetNamePlateForUnit("target");
				if (namePlateTarget) then
					bar = NamePlateDriverFrame:GetClassNameplateBar()
					bar:SetParent(NamePlateTargetResourceFrame)
					bar:Show()
					NamePlateTargetResourceFrame:SetParent(namePlateTarget.UnitFrame)
					NamePlateTargetResourceFrame:ClearAllPoints()
					local tab = core.db.resource
					NamePlateTargetResourceFrame:SetPoint(tab.anchor, namePlateTarget.UnitFrame, tab.relative, tab.x, tab.y)
					NamePlateTargetResourceFrame:GetChildren():Show()
					NamePlateTargetResourceFrame:Show()
					NamePlateTargetResourceFrame:Layout()
				end
			end
			mine = false
		end
	end
	main.PLAYER_TARGET_CHANGED = Update
	--main:RegisterEvent('PLAYER_TARGET_CHANGED')
end)



core:AddCallback('Toggle', 'resource', function(self, ...)
	local state = 'RemoveCallback'
	local reg = 'UnregisterEvent'
	if self.db.resource.enabled then
		state = 'AddCallback'
		reg = 'RegisterEvent'
	end
	main[reg](main, 'PLAYER_ENTERING_WORLD')
	main[reg](main, 'PLAYER_TARGET_CHANGED')
	
	self[state](self, 'NAME_PLATE_UNIT_REMOVED', 'combopoints', function(self, frame)
		main:PLAYER_TARGET_CHANGED()
	end)

	self[state](self, 'NAME_PLATE_UNIT_ADDED', 'combopoints', function(self, frame)
		if hasCP and UnitCanAttack('player', 'target') then
		end
		
	end)
end)
